var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import React from 'react';
import { Formik, FieldArray } from 'formik';
import classNames from 'classnames';
import { Col, Row, UncontrolledTooltip } from 'reactstrap';
import * as _ from 'lodash';
import { FiPlusCircle, FiMinusCircle } from 'react-icons/fi';
import RequiredField from 'components/lib/forms/RequiredField';
import { DisplayFormikState } from './FormikDebug';
import { PromptUnsavedForm } from './PromptUnsavedForm';
import Button from './Button';
import Checkbox from './Checkbox';
import CheckboxGroup from './CheckboxGroup';
import CustomDatePicker from './DatePicker';
import InputText from './InputText';
import InputToggle from './InputToggle';
// import InputDecimal from './InputDecimal';
import InputEmail from './InputEmail';
import InputNumber from './InputNumber';
import Password from './Password';
import RadioButton from './RadioButton';
import ReactSelect from './Select';
var DynamicForm = /** @class */ (function (_super) {
    __extends(DynamicForm, _super);
    function DynamicForm() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    DynamicForm.prototype.componentWillMount = function () {
        this.setState({
            layout: this.props.layout,
            layoutGrid: this.props.layoutGrid,
        });
    };
    DynamicForm.prototype.renderField = function (name, input, form, classes, lClass, dClass) {
        if (input.type === 'multi_select' || input.type === 'select') {
            return this.renderSelect(name, input, form, classes, lClass, dClass);
        }
        if (input.type === 'checkbox_group') {
            return this.renderCheckboxes(name, input, form, classes, lClass, dClass);
        }
        if (input.type === 'checkbox') {
            return this.renderCheckbox(name, input, form, classes, lClass, dClass);
        }
        if (input.type === 'number') {
            return this.renderInputNumber(name, input, form, classes, lClass, dClass);
        }
        /*
        if (input.type === 'textarea') {
          return this.renderTextarea(input);
        }
        */
        if (input.type === 'password') {
            return this.renderPassword(name, input, form, classes, lClass, dClass);
        }
        /*
        if (input.type === 'timepicker') {
          return this.renderTimePicker(input);
        }
        */
        if (input.type === 'datepicker') {
            return this.renderDatePicker(name, input, form, classes, lClass, dClass);
        }
        if (input.type === 'text') {
            return this.renderTextbox(name, input, form, classes, lClass, dClass);
        }
        if (input.type === 'email') {
            return this.renderEmail(name, input, form, classes, lClass, dClass);
        }
        if (input.type === 'radio') {
            return this.renderRadioButtons(name, input, form, classes, lClass, dClass);
        }
        if (input.type === 'toggle') {
            return this.renderToggle(name, input, form, classes, lClass, dClass);
        }
        /*
        if (input.type === 'decimal') {
          return this.renderDecimal(input, form, classes, lClass, dClass);
        }
        */
        if (input.type === 'array_fields') {
            return this.renderArray(input, form, classes);
        }
        if (input.type === 'button') {
            return this.renderButton(name, input, form, input.classNames, lClass, dClass);
        }
    };
    DynamicForm.prototype.renderFields = function (inputs, form, classes, lClass, dClass) {
        var _this = this;
        return inputs.map(function (input) {
            return _this.renderField(input.name, input, form, classes, lClass, dClass);
        });
    };
    DynamicForm.prototype.renderArray = function (input, form, classes) {
        var _a;
        var _this = this;
        var o = {};
        _.map(input.arrayFields.headers, function (i) {
            return (o[i.key] = '');
        });
        var cn;
        if (this.props.layout === 'grid') {
            cn = classNames({
                'col-md-12': true,
            });
            classes = 'col-md-12 no-gutters';
        }
        else if (this.props.layout === 'horizontal') {
            var rg = 12 - this.props.layoutGrid;
            cn = classNames((_a = {},
                _a["offset-md-" + this.props.layoutGrid] = true,
                _a["col-md-" + rg] = true,
                _a));
        }
        return (React.createElement(FieldArray, { key: input.name, name: input.name, render: function (arrayHelpers) { return (React.createElement("div", { className: classes },
                React.createElement("div", { className: cn },
                    React.createElement("table", { className: "table table-bordered" },
                        React.createElement("thead", null,
                            React.createElement("tr", null,
                                input.arrayFields.headers.map(function (i, index) { return (React.createElement("th", { key: i.id + "+" + index },
                                    i.label,
                                    " ",
                                    i.required && React.createElement(RequiredField, null))); }),
                                React.createElement("th", null, "Actions"))),
                        React.createElement("tbody", null, form.values[input.name].map(function (f, rowIndex) {
                            return (React.createElement("tr", { key: f.name + "+" + rowIndex },
                                input.arrayFields.fields.map(function (i, index) {
                                    i.name = input.name + "." + rowIndex + "." + i.id;
                                    return (React.createElement("td", { key: "{i.name}+" + index }, _this.renderField(i.name, i, form, '', '', '')));
                                }),
                                React.createElement("td", null,
                                    React.createElement("div", { className: "btn-group" },
                                        React.createElement("span", { onClick: function () { return arrayHelpers.push(o); }, id: "tt-add-" + input.id + "-" + rowIndex },
                                            React.createElement(FiPlusCircle, { size: 18 })),
                                        React.createElement(UncontrolledTooltip, { placement: "top", target: "tt-add-" + input.id + "-" + rowIndex }, "Add"),
                                        "\u00A0",
                                        React.createElement("span", { onClick: function () {
                                                return rowIndex > 0
                                                    ? arrayHelpers.remove(rowIndex)
                                                    : null;
                                            }, id: "tt-remove-" + input.id + "-" + rowIndex },
                                            React.createElement(FiMinusCircle, { size: 18 })),
                                        React.createElement(UncontrolledTooltip, { placement: "top", target: "tt-remove-" + input.id + "-" + rowIndex }, "Remove")))));
                        })))))); } }));
    };
    /*
    renderDecimal(
      input: FieldConfig,
      form: any,
      classes: any,
      lClass: string,
      dClass: string
    ) {
      return <InputDecimal field={input} form={form} classes={classes} lClass={lClass}
      dClass={dClass} />;
    }
    */
    DynamicForm.prototype.renderInputNumber = function (name, input, form, classes, lClass, dClass) {
        return (React.createElement(InputNumber, { name: name, key: name, field: input, form: form, classes: classes, lClass: lClass, dClass: dClass }));
    };
    DynamicForm.prototype.renderPassword = function (name, input, form, classes, lClass, dClass) {
        return (React.createElement(Password, { name: name, key: name, field: input, form: form, classes: classes, lClass: lClass, dClass: dClass }));
    };
    DynamicForm.prototype.renderToggle = function (name, input, form, classes, lClass, dClass) {
        return (React.createElement(InputToggle, { name: name, key: name, field: input, form: form, classes: classes, lClass: lClass, dClass: dClass }));
    };
    DynamicForm.prototype.renderTextbox = function (name, input, form, classes, lClass, dClass) {
        // input.arrayIndex = index;
        return (React.createElement(InputText, { key: name, field: input, form: form, name: name, classes: classes, lClass: lClass, dClass: dClass }));
    };
    DynamicForm.prototype.renderEmail = function (name, input, form, classes, lClass, dClass) {
        return (React.createElement(InputEmail, { key: name, field: input, form: form, name: name, classes: classes, lClass: lClass, dClass: dClass }));
    };
    DynamicForm.prototype.renderCheckbox = function (name, input, form, classes, lClass, dClass) {
        return (React.createElement(Checkbox, { name: name, key: name, field: input, form: form, classes: classes, lClass: lClass, dClass: dClass }));
    };
    DynamicForm.prototype.renderCheckboxes = function (name, input, form, classes, lClass, dClass) {
        return (React.createElement(CheckboxGroup, { name: name, key: name, field: input, form: form, classes: classes, lClass: lClass, dClass: dClass }));
    };
    DynamicForm.prototype.renderRadioButtons = function (name, input, form, classes, lClass, dClass) {
        return (React.createElement(RadioButton, { name: name, key: name, field: input, form: form, classes: classes, lClass: lClass, dClass: dClass }));
    };
    DynamicForm.prototype.renderButton = function (name, input, form, classes, lClass, dClass, buttonType) {
        return (React.createElement(Button, { name: name, key: name, field: input, form: form, classes: classes, lClass: lClass, dClass: dClass, buttonType: buttonType }));
    };
    DynamicForm.prototype.renderDatePicker = function (name, input, form, classes, lClass, dClass) {
        return (React.createElement(CustomDatePicker, { name: name, key: name, field: input, form: form, classes: classes, lClass: lClass, dClass: dClass }));
    };
    /*
    renderFile(input: FieldConfig) {}
  
    renderTextarea(input: FieldConfig) {}
  
    renderTimePicker(input: FieldConfig) {}
  
    renderDateTimePicker(
      input: FieldConfig,
      form: any,
      classes: any,
      lClass: string,
      dClass: string
    ) {
      return (
        <CustomDatePicker
  
          key={input.id}
          field={input}
          form={form}
          classes={classes}
          lClass={lClass}
          dClass={dClass}
        />
      );
    }
    */
    DynamicForm.prototype.renderSelect = function (name, input, form, classes, lClass, dClass) {
        // input.arrayIndex = index;
        return (React.createElement(ReactSelect, { name: name, key: name, value: form.values[input.name], field: input, form: form, classes: classes, lClass: lClass, dClass: dClass, isMulti: input.isMulti, onChange: form.setFieldValue, onBlur: form.setFieldTouched, onEvent: this.props.changeHandler }));
    };
    DynamicForm.prototype.getInitialValues = function (inputs) {
        var initialValues = {};
        inputs.forEach(function (field) {
            if (!initialValues[field.name]) {
                initialValues[field.name] = field.value;
            }
        });
        return initialValues;
    };
    DynamicForm.prototype.render = function () {
        var _a, _b, _c, _d;
        var _this = this;
        var initialValues = this.getInitialValues(this.props.fields);
        var formContainerClass = classNames({
            row: this.props.layout === 'grid',
            right: this.props.labelPosition === 'right',
        });
        var cn;
        if (this.props.layout === 'grid') {
            cn = classNames((_a = {
                    'form-group': true
                },
                _a["col-md-" + this.props.layoutGrid] = true,
                _a));
        }
        else if (this.props.layout === 'vertical') {
            cn = classNames({
                'form-group': true,
            });
        }
        else if (this.props.layout === 'horizontal') {
            cn = classNames({
                'form-group': true,
                row: true,
            });
        }
        var lClass = '';
        var dClass = '';
        var bClass = '';
        var bCnClass = cn;
        if (this.props.layout === 'horizontal') {
            lClass = classNames((_b = {},
                _b["col-md-" + this.props.layoutGrid] = true,
                _b));
            var rg = 12 - this.props.layoutGrid;
            dClass = classNames((_c = {},
                _c["col-md-" + rg] = true,
                _c));
            formContainerClass = classNames({
                horizontal: true,
                right: this.props.labelPosition === 'right',
            });
            bClass = classNames((_d = {},
                _d["offset-md-" + this.props.layoutGrid] = true,
                _d));
        }
        if (this.props.layout === 'grid') {
            bCnClass = classNames({
                'form-group': true,
            });
        }
        bClass = classNames(bClass, {
            'text-right': this.props.form.buttonPosition === 'right',
        });
        return (React.createElement(Formik, { key: this.props.key, enableReinitialize: true, onSubmit: function (values) {
                _this.props.onFormSubmit(values);
            }, validationSchema: this.props.validation, initialValues: initialValues }, function (formik) { return (React.createElement("div", null,
            React.createElement(Row, null,
                React.createElement(Col, { sm: { size: 12 } },
                    React.createElement("div", null,
                        React.createElement("form", { onSubmit: formik.handleSubmit },
                            _this.props.promptIfUnsaved ? React.createElement(PromptUnsavedForm, null) : '',
                            React.createElement("div", { className: formContainerClass }, _this.renderFields(_this.props.fields, formik, cn, lClass, dClass)),
                            React.createElement("div", { className: bCnClass },
                                React.createElement("div", { className: bClass + " " + dClass }, _this.renderFields(_this.props.form.buttons, formik, cn, lClass, dClass))))))),
            _this.props.form.isDebug && (React.createElement(Row, null,
                React.createElement(Col, { sm: { size: 12 } },
                    React.createElement(DisplayFormikState, __assign({}, formik))))))); }));
    };
    DynamicForm.defaultProps = {
        layout: 'vertical',
        layoutGrid: 12,
        labelPosition: 'left',
        key: '',
    };
    return DynamicForm;
}(React.PureComponent));
export default DynamicForm;
//# sourceMappingURL=DynamicForm.js.map