import * as Yup from 'yup';
export default function createYupSchema(schema, config) {
    var id = config.id, type = config.type, _a = config.validations, validations = _a === void 0 ? [] : _a;
    // let validationType: any = type;
    var inputTypes = [
        'text',
        'email',
        'radio',
        'datepicker',
        'select',
        'password',
        'number',
    ];
    if (inputTypes.includes(type)) {
        type = 'string';
    }
    var arrayTypes = ['checkbox_group', 'multi_select'];
    if (arrayTypes.includes(type)) {
        type = 'array';
    }
    if (!Yup[type]) {
        return schema;
    }
    var validator = Yup[type]();
    validations.forEach(function (validation) {
        var params = validation.params, type = validation.type;
        if (!validator[type]) {
            return;
        }
        validator = validator[type].apply(validator, params);
    });
    schema[id] = validator;
    return schema;
}
//# sourceMappingURL=YupSchemaGenerator.js.map