import React from 'react';
import _ from 'lodash';
import DatePicker from 'react-datepicker';

import { Field, ErrorMessage } from 'formik';

import RequiredField from './forms/RequiredField';

import InputProps from 'models/InputProps';

export default class CustomDatePicker extends React.PureComponent<
  InputProps,
  any
> {
  render() {
    let label: any;
    let classNames: string;

    if (!this.props.field.isArrayField) {
      label = (
        <label className={this.props.lClass} htmlFor={this.props.field.id}>
          {this.props.field.label}{' '}
          {this.props.field.isRequired && <RequiredField />}
        </label>
      );
      classNames = 'form-control';
    } else {
      classNames = 'form-control';
    }

    return (
      <div className={this.props.classes} key={this.props.name}>
        {label}
        <div className={this.props.dClass}>
          <Field type="text" name={this.props.name}>
            {(FieldProp: any) => (
              <DatePicker
                id={this.props.name}
                name={this.props.name}
                selected={
                  (this.props.field.value &&
                    new Date(this.props.field.value)) ||
                  null
                }
                dateFormat="dd/MM/yyyy"
                autoComplete="off"
                onChange={(v: any) => {
                  this.props.field.value = v;
                  this.props.form.setFieldValue(this.props.name, v);
                }}
                className={
                  classNames +
                  (_.get(FieldProp.form.errors, this.props.name) &&
                  _.get(FieldProp.form.touched, this.props.name)
                    ? ' is-invalid '
                    : '')
                }
              />
            )}
          </Field>
          <ErrorMessage
            name={this.props.name}
            component="div"
            className="required"
          />
        </div>
      </div>
    );
  }
}
