import * as React from 'react';
import { CustomInput } from 'reactstrap';

import { Field, ErrorMessage } from 'formik';

export default class InputToggle extends React.PureComponent<any> {
  render() {
    return (
      <div className={this.props.classes}>
        <label className={this.props.lClass}>{this.props.field.title}</label>
        <div className={this.props.dClass}>
          <Field name={this.props.name}>
            {(FieldProp: any) => (
              <CustomInput
                type="switch"
                id={this.props.name}
                name={this.props.name}
                onChange={this.props.form.handleChange}
                value={this.props.field.value}
                label={this.props.field.label}
                {...FieldProp.field}
              />
            )}
          </Field>
          <ErrorMessage
            name={this.props.name}
            component="div"
            className="required"
          />
        </div>
      </div>
    );
  }
}
